﻿using System;

namespace project_39_7 {
  class SchoolMember {
    private string _name;
    private int _age;

    //Define the constructor
    public SchoolMember(string name, int age) {
      this.Name = name;
      this.Age = age;
      Console.WriteLine("A school member was initialized");
    }

    //Define public property Name
    public string Name {
      //Define the getter
      get {
        return this._name;
      }

      //Define the setter
      set {
        if (value != "")
          this._name = value;
        else
          throw new Exception("Name cannot be empty");
      }
    }

    //Define public property Age
    public int Age {
      //Define the getter
      get {
        return this._age;
      }

      //Define the setter
      set {
        if (value > 0)
          this._age = value;
        else
          throw new Exception("Age cannot be negative or zero");
      }
    }
  }

  class Teacher : SchoolMember {
    private double _salary;  //This is an additional field for class Teacher

    //Define the constructor
    public Teacher(string name, int age, double salary) : base(name, age) {
      this.Salary = salary;
      Console.WriteLine("A teacher was initialized");
    }

    //Define public property Salary
    public double Salary {
      //Define the getter
      get {
        return this._salary;
      }

      //Define the setter
      set {
        if (value >= 0)
          this._salary = value;
        else
          throw new Exception("Salary cannot be negative");
      }
    }
  }

  class Student : SchoolMember {
    private int[] _grades = new int[3];  //This is an additional field for class Student

    //Define the constructor
    public Student(string name, int age, int[] grades) : base(name, age) {
      this.Grades = grades;
      Console.WriteLine("A student was initialized");
    }

    //Define public property Grades
    public int[] Grades {
      //Define the getter
      get {
        return this._grades;
      }

      //Define the setter
      set {
        //value here is an array. Check if negative grade exists in value
        bool negative_found = false;
        foreach (var v in value) {
          if (v < 0)
            negative_found = true;
        }

        if (!negative_found)
          this._grades = value;
        else
          throw new Exception("Grades cannot be negative");
      }
    }
  }

  class Program {
    static void Main(string[] args) {
      Teacher teacher1 = new Teacher("Mr. John Scott", 43, 35000);
      Teacher teacher2 = new Teacher("Mrs. Ann Carter", 5, 32000);

      Student student1 = new Student("Mark Nelson", 14, new int[] { 90, 95, 92 });
      Student student2 = new Student("Mary Morgan", 13, new int[] { 92, 97, 94 });

      Console.WriteLine(teacher1.Name);
      Console.WriteLine(teacher1.Age);
      Console.WriteLine(teacher1.Salary);

      Console.WriteLine(student2.Name);
      Console.WriteLine(student2.Age);
      foreach (var grade in student2.Grades) {
        Console.WriteLine(grade);
      }
    }
  }

}
